#line 945 "../../src/builtin/snarf.m4"
/* -*- buffer-read-only: t -*- vi: set ro:
   THIS FILE IS GENERATED AUTOMATICALLY.  PLEASE DO NOT EDIT.
*/
#line 945
#ifdef HAVE_CONFIG_H
#line 945
# include <config.h>
#line 945
#endif
#line 945
#include <sys/types.h>
#line 945

#line 945
#include "mailfromd.h"
#line 945
#include "prog.h"
#line 945
#include "builtin.h"
#line 945

#line 92 "mbox.bi"
static mu_debug_handle_t debug_handle;
#line 945 "../../src/builtin/snarf.m4"

#line 985 "../../src/builtin/snarf.m4"

/* End of snarf.m4 */
#line 1 "mbox.bi"
/* This file is part of Mailfromd.             -*- c -*-
   Copyright (C) 2008-2020 Sergey Poznyakoff

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 3, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>. */



#include "msg.h"
#include "global.h"

static size_t nmboxes = MAX_MBOXES;

static struct mu_cfg_param mbox_cfg_param[] = {
	{ "max-open-mailboxes", mu_c_size, &nmboxes, 0, NULL,
	  N_("Maximum number of mailboxes to open simultaneously.") },
	{ NULL }
};

static int
do_close(void *item, void *data)
{
	bi_close_message(item);
	return 0;
}

static void
close_mbox(struct mf_mbox *mp)
{
	if (mp->mbox) {
		mu_mailbox_close(mp->mbox);
		mu_mailbox_destroy(&mp->mbox);
		mu_list_foreach(mp->msglist, do_close, NULL);
		mu_list_destroy(&mp->msglist);
		memset(mp, 0, sizeof mp[0]);
	}
}

static void *
alloc_mboxes()
{
	return mu_calloc(nmboxes, sizeof(struct mf_mbox));
}

static void
destroy_mboxes(void *data)
{
	struct mf_mbox *mtab = data;
	struct mf_mbox *p;
	for (p = mtab; p < mtab + nmboxes; p++) {
		close_mbox(p);
	}
	free(mtab);
}


#line 66

#line 66
static int MBOXTAB_id;
#line 66 "mbox.bi"


static int
find_slot(struct mf_mbox *tab)
{
	int i;
	for (i = 0; i < nmboxes; i++)
		if (tab[i].mbox == NULL)
			return i;
	return -1;
}

/* number mailbox_open(string url) */
void
#line 79
bi_mailbox_open(eval_environ_t env)
#line 79

#line 79

#line 79 "mbox.bi"
{
#line 79
	
#line 79

#line 79
long __bi_argcnt;
#line 79
char *  url;
#line 79
        char *  mode;
#line 79
        char *  perms;
#line 79
        
#line 79
get_string_arg(env, 1, &url);
#line 79
        get_string_arg(env, 2, &mode);
#line 79
        get_string_arg(env, 3, &perms);
#line 79
        
#line 79
get_numeric_arg(env, 0, &__bi_argcnt);
#line 79
        adjust_stack(env, __bi_argcnt + 1);
#line 79

#line 79

#line 79
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 79
		prog_trace(env, "mailbox_open %s %s %s",url, ((__bi_argcnt > 1) ? mode : ""), ((__bi_argcnt > 2) ? perms : ""));;
#line 79

{
	int rc;
	int md;
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
	struct mf_mbox *mp;
	int flags;
	char *p;

	md = find_slot(mbtab);
		if (!(md >= 0))
#line 89
		(
#line 89
	env_throw_bi(env, mfe_failure, "mailbox_open", _("no more mailboxes available"))
#line 89
)
#line 91
;
	
#line 92 "mbox.bi"

#line 92
mu_debug(debug_handle, MU_DEBUG_TRACE1,("opening mailbox %s", url));
	mp = mbtab + md;

	flags = 0;
	for (p = ((__bi_argcnt > 1) ? mode : "r"); *p; p++) {
		switch (*p) {
		case 'a':
			flags |= MU_STREAM_APPEND;
			break;
			
		case 'r':
			flags |= MU_STREAM_READ;
			break;
			
		case 'w':
			flags |= MU_STREAM_WRITE;
			break;
			
		case '+':
			if (flags & MU_STREAM_READ)
				flags |= MU_STREAM_WRITE;
			else if (flags & MU_STREAM_WRITE)
				/* FIXME: should truncate as well */
				flags |= MU_STREAM_READ|MU_STREAM_CREAT;
			else if (flags & MU_STREAM_APPEND) {
				flags |= MU_STREAM_RDWR | MU_STREAM_CREAT;
			} else
				(
#line 119
	env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p)
#line 119
);
#line 122
			break;

		default:
			(
#line 125
	env_throw_bi(env, mfe_range, "mailbox_open", _("incorrect mode near `%s'"),p)
#line 125
);
#line 128
		}
	}

	/* FIXME: MU: This is ridiculous! */
	if ((flags & (MU_STREAM_READ|MU_STREAM_WRITE))
	    == (MU_STREAM_READ|MU_STREAM_WRITE)) {
		    flags &= ~(MU_STREAM_READ|MU_STREAM_WRITE);
		    flags |= MU_STREAM_RDWR;
	}
	    
	if ((__bi_argcnt > 2)) {
		/* If MU_STREAM_IRGRP is defined, the remaining three
		   permissions flags are defined as well.
		   FIXME: Remove ifdef when MU 2.0 is out. */
#ifdef MU_STREAM_IRGRP
		int f;
		const char *p;
			if (!(mu_parse_stream_perm_string(&f, ((__bi_argcnt > 2) ? perms : 0), &p)
#line 145
			  == 0))
#line 145
		(
#line 145
	env_throw_bi(env, mfe_range, "mailbox_open", /* FIXME: introduce mfe_inval? */
			  _("invalid permissions (near %s)"),p)
#line 145
)
#line 148
;
		flags |= f;
#else
		(
#line 151
	env_throw_bi(env, mfe_failure, "mailbox_open", _("this version of Mailutils does not support "
			   "configurable mailbox permissions"))
#line 151
);
#line 154
#endif
	}
		
	rc = mu_mailbox_create(&mp->mbox, url);
		if (!(rc == 0))
#line 158
		(
#line 158
	env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot create mailbox `%s': %s"),url,mu_strerror(rc))
#line 158
)
#line 161
;
	rc = mu_mailbox_open(mp->mbox, flags);
	if (rc) {
		mu_mailbox_destroy(&mp->mbox);
		(
#line 165
	env_throw_bi(env, mfe_failure, "mailbox_open", _("cannot open mailbox `%s': %s"),url,mu_strerror(rc))
#line 165
);
#line 168
	}
	mu_list_create(&mp->msglist);
	
	
#line 171
do {
#line 171
  push(env, (STKVAL)(mft_number)(md));
#line 171
  goto endlab;
#line 171
} while (0);
}
endlab:
#line 173
        env_function_cleanup_flush(env, NULL);
#line 173
	return;
#line 173
}

/* void mailbox_close(number mbx) */
void
#line 176
bi_mailbox_close(eval_environ_t env)
#line 176

#line 176

#line 176 "mbox.bi"
{
#line 176
	
#line 176

#line 176

#line 176
long  md;
#line 176
        
#line 176
get_numeric_arg(env, 0, &md);
#line 176
        
#line 176

#line 176
        adjust_stack(env, 1);
#line 176

#line 176

#line 176
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 176
		prog_trace(env, "mailbox_close %lu",md);;
#line 176

{
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);

		if (!(md >= 0 && md < nmboxes))
#line 180
		(
#line 180
	env_throw_bi(env, mfe_range, "mailbox_close", _("invalid mailbox descriptor"))
#line 180
)
#line 182
;
	close_mbox(mbtab + md);
}

#line 185
        env_function_cleanup_flush(env, NULL);
#line 185
	return;
#line 185
}

#line 198

	
/* number mailbox_messages_count(number mbx) */
void
#line 201
bi_mailbox_messages_count(eval_environ_t env)
#line 201

#line 201

#line 201 "mbox.bi"
{
#line 201
	
#line 201

#line 201

#line 201
long  nmbx;
#line 201
        
#line 201
get_numeric_arg(env, 0, &nmbx);
#line 201
        
#line 201

#line 201
        adjust_stack(env, 1);
#line 201

#line 201

#line 201
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 201
		prog_trace(env, "mailbox_messages_count %lu",nmbx);;
#line 201

{
	size_t count;
	int rc;
	
#line 205
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 205
	struct mf_mbox *mp;
#line 205
			
#line 205
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 205
		(
#line 205
	env_throw_bi(env, mfe_range, "mailbox_messages_count", _("invalid mailbox descriptor"))
#line 205
)
#line 205
;
#line 205
	mp = mbtab + nmbx;
#line 205
		if (!(mp->mbox))
#line 205
		(
#line 205
	env_throw_bi(env, mfe_failure, "mailbox_messages_count", _("mailbox not open"))
#line 205
)
#line 205

#line 205
;
	
	rc = mu_mailbox_messages_count(mp->mbox, &count);
		if (!(rc == 0))
#line 208
		(
#line 208
	env_throw_bi(env, mfe_failure, "mailbox_messages_count", "%s",mu_strerror(rc))
#line 208
)
#line 211
;
	
#line 212
do {
#line 212
  push(env, (STKVAL)(mft_number)(count));
#line 212
  goto endlab;
#line 212
} while (0);
}
endlab:
#line 214
        env_function_cleanup_flush(env, NULL);
#line 214
	return;
#line 214
}

/* number mailbox_get_message(number mbx, number msg-no) */
void
#line 217
bi_mailbox_get_message(eval_environ_t env)
#line 217

#line 217

#line 217 "mbox.bi"
{
#line 217
	
#line 217

#line 217

#line 217
long  nmbx;
#line 217
        long  msgno;
#line 217
        
#line 217
get_numeric_arg(env, 0, &nmbx);
#line 217
        get_numeric_arg(env, 1, &msgno);
#line 217
        
#line 217

#line 217
        adjust_stack(env, 2);
#line 217

#line 217

#line 217
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 217
		prog_trace(env, "mailbox_get_message %lu %lu",nmbx, msgno);;
#line 217

{
	int rc;
	mu_message_t msg;
	
#line 221
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 221
	struct mf_mbox *mp;
#line 221
			
#line 221
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 221
		(
#line 221
	env_throw_bi(env, mfe_range, "mailbox_get_message", _("invalid mailbox descriptor"))
#line 221
)
#line 221
;
#line 221
	mp = mbtab + nmbx;
#line 221
		if (!(mp->mbox))
#line 221
		(
#line 221
	env_throw_bi(env, mfe_failure, "mailbox_get_message", _("mailbox not open"))
#line 221
)
#line 221

#line 221
;

	rc = mu_mailbox_get_message(mp->mbox, msgno, &msg);
		if (!(rc == 0))
#line 224
		(
#line 224
	env_throw_bi(env, mfe_failure, "mailbox_get_message", "%s",mu_strerror(rc))
#line 224
)
#line 227
;
	rc = bi_message_register(env, mp->msglist, msg, MF_MSG_MAILBOX);
		if (!(rc >= 0))
#line 229
		(
#line 229
	env_throw_bi(env, mfe_failure, "mailbox_get_message", _("no more message slots available"))
#line 229
)
#line 231
;
	
#line 232
do {
#line 232
  push(env, (STKVAL)(mft_number)(rc));
#line 232
  goto endlab;
#line 232
} while (0);
}
endlab:
#line 234
        env_function_cleanup_flush(env, NULL);
#line 234
	return;
#line 234
}

/* void mailbox_append_message(number mbx, number msg-no) */
void
#line 237
bi_mailbox_append_message(eval_environ_t env)
#line 237

#line 237

#line 237 "mbox.bi"
{
#line 237
	
#line 237

#line 237

#line 237
long  nmbx;
#line 237
        long  msgno;
#line 237
        
#line 237
get_numeric_arg(env, 0, &nmbx);
#line 237
        get_numeric_arg(env, 1, &msgno);
#line 237
        
#line 237

#line 237
        adjust_stack(env, 2);
#line 237

#line 237

#line 237
	if (builtin_module_trace(BUILTIN_IDX_mbox))
#line 237
		prog_trace(env, "mailbox_append_message %lu %lu",nmbx, msgno);;
#line 237

{
	int rc;
	mu_message_t msg;
	
#line 241
	struct mf_mbox *mbtab = env_get_builtin_priv(env,MBOXTAB_id);
#line 241
	struct mf_mbox *mp;
#line 241
			
#line 241
		if (!(nmbx >= 0 && nmbx < nmboxes))
#line 241
		(
#line 241
	env_throw_bi(env, mfe_range, "mailbox_append_message", _("invalid mailbox descriptor"))
#line 241
)
#line 241
;
#line 241
	mp = mbtab + nmbx;
#line 241
		if (!(mp->mbox))
#line 241
		(
#line 241
	env_throw_bi(env, mfe_failure, "mailbox_append_message", _("mailbox not open"))
#line 241
)
#line 241

#line 241
;

	msg = bi_message_from_descr(env, msgno);
	rc = mu_mailbox_append_message(mp->mbox, msg);
		if (!(rc == 0))
#line 245
		(
#line 245
	env_throw_bi(env, mfe_failure, "mailbox_append_message", _("cannot append message: %s"),mu_strerror(rc))
#line 245
)
#line 248
;
}

#line 250
        env_function_cleanup_flush(env, NULL);
#line 250
	return;
#line 250
}

 
#line 945 "../../src/builtin/snarf.m4"

#line 945

#line 945

#line 945
void
#line 945
mbox_init_builtin(void)
#line 945
{
#line 945
		debug_handle = mu_debug_register_category("bi_mbox");
#line 945

#line 945
	#line 66 "mbox.bi"
MBOXTAB_id = builtin_priv_register(alloc_mboxes, destroy_mboxes,
#line 66
NULL);
#line 79 "mbox.bi"
va_builtin_install_ex("mailbox_open", bi_mailbox_open, 0, dtype_number, 3, 2, 0|0, dtype_string, dtype_string, dtype_string);
#line 176 "mbox.bi"
va_builtin_install_ex("mailbox_close", bi_mailbox_close, 0, dtype_unspecified, 1, 0, 0|0, dtype_number);
#line 201 "mbox.bi"
va_builtin_install_ex("mailbox_messages_count", bi_mailbox_messages_count, 0, dtype_number, 1, 0, 0|0, dtype_number);
#line 217 "mbox.bi"
va_builtin_install_ex("mailbox_get_message", bi_mailbox_get_message, 0, dtype_number, 2, 0, 0|0, dtype_number, dtype_number);
#line 237 "mbox.bi"
va_builtin_install_ex("mailbox_append_message", bi_mailbox_append_message, 0, dtype_unspecified, 2, 0, 0|0, dtype_number, dtype_number);

#line 945 "../../src/builtin/snarf.m4"
	
#line 945
	 mf_add_runtime_params(mbox_cfg_param);
#line 945
	 
#line 945
}
#line 945 "../../src/builtin/snarf.m4"

